# CraftPresence

## [v1.5.0](https://github.com/CDAGaming/CraftPresence-Wow-Edition/tree/v1.5.0) (2021-06-02)
[Full Changelog](https://github.com/CDAGaming/CraftPresence-Wow-Edition/compare/v1.4.5...v1.5.0) [Previous Releases](https://github.com/CDAGaming/CraftPresence-Wow-Edition/releases)

- [Change] Locale polish  
    - `DEBUG\_VALUE\_CHANGED` logging is now appropriately colored to be more readable  
    - `ERROR\_FUNCTION\_DEPRECATED`, `ERROR\_FUNCTION`, and `ERROR\_FUNCTION\_REPLACE` have each also undergone adjustments to be more readable.  
- [Change] Code Cleanup and minor fixes  
    - [Fix] Fixed an issue where `prefix` was unable to be user-defined  
    - [Backend] Simplified keyPrefix usage at the end of `ParseGameData` to avoid duplicated calls  
    - [Backend] Remove unused types in `Deprecated\_Functions` and fix an issue where `unitData` in `GetPlayerStatus` was unintentionally overridden.  
    - [Change] Store `GetUnitData` as a variable for the `PLAYER\_FLAGS\_CHANGED` ignoreCallback (Use `/cp reset events PLAYER\_FLAGS\_CHANGED` to get this change)  
- [Change] Modified how deprecated and erroring functions are logged  
    - Deprecated Function warnings can now specify which version they will be removed in.  
    - Deprecated function warnings will now show 'None' and 'Unknown' for the replacement function and removal version accordingly, as fallbacks if either is null or empty.  
    - Functions that fail to process in `loadstring` in `GetDynamicReturnValue` will now display a more informative log message as well as the source function being called.  
- [Change] Moved Deprecation Date up to v2.0.0  
    - Allows more time for users to move off these deprecated functions  
- [Change] Placeholder Rewrite v2  
    Notes:  
    - Allows Usage of metadata value indicators.  
      - Keys prefixed by this indicator will not be parsed in the frontend portions of the codebase, but are used for table-defining behaviors. For this commit, this metadata value is used for specifying whether a placeholder category has a prefix or not (In which case, global and inner placeholders have configurable prefixes but custom placeholders do not require any prefix).  
      - While this technically means that empty prefixes are now possible for global and inner placeholders, prefixes will still be required for proper usage, as the migration layer can majorly bug out if it tries to replace whitespace.  
    - `setfmt` usage has been removed from `GameUtils` as unneeded. In the initial table, placeholders no longer contain the prefix and are instead stored as their string identifiers. The prefixes are applied as needed in different areas of the codebase.  
    - Conditional info in `ParseGameData` has received documentation to better detail how conditionals are parsed. Cleanup on these areas may be done soon due to `GetOrDefault` being available.  
